<div class="container">
  <div class="row">
    <div class="col-xs-12 col-sm-10 col-md-8 col-sm-offset-1 col-md-offset-2">
      <form [formGroup]="signupForm" (ngSubmit)="onSubmit()">
        <div formGroupName="userdata">
          <div class="form-group">
            <label for="username">Username</label>
            <input
              type="text"
              id="username"
              class="form-control"
              formControlName="username"
            />
            <span
              class="help-block"
              *ngIf="
                signupForm.get('userdata.username').touched &&
                !signupForm.get('userdata.username').valid
              "
            >
              <span
                *ngIf="signupForm.get('userdata.username').errors['required']"
                >The field is required.</span
              >
              <span
                *ngIf="
                  signupForm.get('userdata.username').errors['nameIsForbidden']
                "
                >The username is not allowed.</span
              >
            </span>
            <div>
              <button
                class="btn btn-default"
                type="button"
                (click)="suggestUsername()"
              >
                Suggest Username
              </button>
            </div>
          </div>
          <div class="form-group">
            <label for="email">Email</label>
            <input
              type="text"
              id="email"
              class="form-control"
              formControlName="email"
            />
            <span *ngIf="signupForm.get('userdata.email').pending">
              Checking for valid email...
            </span>
            <span
              class="help-block"
              *ngIf="
                !signupForm.get('userdata.email').valid &&
                signupForm.get('userdata.email').touched
              "
              >Please enter a valid email!</span
            >
          </div>
        </div>
        <div class="radio" *ngFor="let gender of genders">
          <label>
            <input type="radio" [value]="gender" formControlName="gender" />{{
              gender
            }}
          </label>
        </div>
        <div formArrayName="hobbies">
          <h4>Your Hobbies:</h4>
          <button class="btn btn-default" type="button" (click)="onAddHobby()">
            Add Hobby
          </button>
          <div
            class="form-group"
            *ngFor="let hobbyControl of getHobbyControls(); let i = index"
          >
            <input type="text" class="form-control" [formControlName]="i" />
          </div>
        </div>
        <span class="help-block" *ngIf="!signupForm.valid && signupForm.touched"
          >Please enter valid data!</span
        >
        <button class="btn btn-primary" type="submit">Submit</button>
        <div>
          <button class="btn btn-primary" type="button" (click)="onAutofill()">
            Auto Fill
          </button>
        </div>
      </form>
    </div>
  </div>
</div>
